package cn.com.infosec.ocsp;

import cn.com.infosec.asn1.ASN1InputStream;
import cn.com.infosec.asn1.ASN1OutputStream;
import cn.com.infosec.asn1.ocsp.BasicOCSPResponse;
import cn.com.infosec.asn1.ocsp.OCSPObjectIdentifiers;
import cn.com.infosec.asn1.ocsp.OCSPResponse;
import cn.com.infosec.asn1.ocsp.ResponseBytes;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;

public class OCSPResp {
   private OCSPResponse resp;

   public OCSPResp(OCSPResponse resp) {
      this.resp = resp;
   }

   public OCSPResp(byte[] resp) {
      OCSPResp var10000 = this;
      ASN1InputStream var2;
      var2 = new ASN1InputStream.<init>(resp);
      var10000.<init>(var2);
   }

   public OCSPResp(InputStream in) {
      OCSPResp var10000 = this;
      ASN1InputStream var2;
      var2 = new ASN1InputStream.<init>(in);
      var10000.<init>(var2);
   }

   private OCSPResp(ASN1InputStream aIn) {
      OCSPResp var10000 = this;
      ASN1InputStream var10001 = aIn;
      super();

      try {
         var10000.resp = OCSPResponse.getInstance(var10001.readObject());
      } catch (IllegalArgumentException var2) {
         throw new IOException("malformed response: " + var2.getMessage());
      } catch (ClassCastException var3) {
         throw new IOException("malformed response: " + var3.getMessage());
      }
   }

   public int getStatus() {
      return this.resp.getResponseStatus().getValue().intValue();
   }

   public Object getResponseObject() {
      ResponseBytes var4;
      if ((var4 = this.resp.getResponseBytes()) == null) {
         return null;
      } else if (var4.getResponseType().equals(OCSPObjectIdentifiers.id_pkix_ocsp_basic)) {
         Exception var10000;
         label31: {
            boolean var10001;
            ASN1InputStream var6;
            try {
               var6 = new ASN1InputStream;
            } catch (Exception var3) {
               var10000 = var3;
               var10001 = false;
               break label31;
            }

            ASN1InputStream var1 = var6;

            try {
               var6.<init>(var4.getResponse().getOctets());
               return new BasicOCSPResp(BasicOCSPResponse.getInstance(var1.readObject()));
            } catch (Exception var2) {
               var10000 = var2;
               var10001 = false;
            }
         }

         Exception var5 = var10000;
         throw new OCSPException("problem decoding object: " + var5, var5);
      } else {
         return var4.getResponse();
      }
   }

   public byte[] getEncoded() {
      ByteArrayOutputStream var1;
      ByteArrayOutputStream var10000 = var1 = new ByteArrayOutputStream;
      var10000.<init>();
      (new ASN1OutputStream(var1)).writeObject(this.resp);
      return var10000.toByteArray();
   }

   public boolean equals(Object o) {
      if (o == this) {
         return true;
      } else if (!(o instanceof OCSPResp)) {
         return false;
      } else {
         OCSPResp var10000 = this;
         OCSPResp var2 = (OCSPResp)o;
         return var10000.resp.equals(var2.resp);
      }
   }

   public int hashCode() {
      return this.resp.hashCode();
   }
}
